##################################################################################################
# Istio Gateway and VirtualService configuration
##################################################################################################
apiVersion: networking.istio.io/v1alpha3
kind: Gateway
metadata:
  name: microservice-gateway
spec:
  selector:
    istio: ingressgateway
  servers:
  - port:
      number: 80
      name: http
      protocol: HTTP
    hosts:
    - "*"
---
apiVersion: networking.istio.io/v1alpha3
kind: VirtualService
metadata:
  name: microservice1
spec:
  hosts:
  - microservice1
  gateways:
  - microservice-gateway
  http:
  - route:
    - destination:
        host: microservice2
        subset: v1
        port:
          number: 9080
      weight: 10
    - destination:
        host: microservice3
        subset: v2
        port:
          number: 9080
      weight: 90
---
apiVersion: networking.istio.io/v1alpha3
kind: DestinationRule
metadata:
  name: microservice2
spec:
  host: microservice2
  subsets:
  - name: v1
    labels:
      version: v1
---
apiVersion: networking.istio.io/v1alpha3
kind: DestinationRule
metadata:
  name: microservice3
spec:
  host: microservice3
  subsets:
  - name: v2
    labels:
      version: v2